diff --git a/include/wchar.h b/include/wchar.h
index 7bf042c235..eb472daefb 100644
--- a/include/wchar.h
+++ b/include/wchar.h
@@ -70,6 +70,26 @@ libc_hidden_proto (wcstoll)
 libc_hidden_proto (wcstoul)
 libc_hidden_proto (wcstoull)
 
+extern float ____wcstof_l_internal (const wchar_t *, wchar_t **, int,
+				    locale_t) attribute_hidden;
+extern double ____wcstod_l_internal (const wchar_t *, wchar_t **, int,
+				     locale_t) attribute_hidden;
+extern long double ____wcstold_l_internal (const wchar_t *, wchar_t **,
+					   int, locale_t) attribute_hidden;
+extern long int ____wcstol_l_internal (const wchar_t *, wchar_t **, int,
+				       int, locale_t) attribute_hidden;
+extern unsigned long int ____wcstoul_l_internal (const wchar_t *,
+						 wchar_t **,
+						 int, int, locale_t)
+     attribute_hidden;
+extern long long int ____wcstoll_l_internal (const wchar_t *, wchar_t **,
+					     int, int, locale_t)
+     attribute_hidden;
+extern unsigned long long int ____wcstoull_l_internal (const wchar_t *,
+						       wchar_t **, int, int,
+						       locale_t)
+     attribute_hidden;
+
 #if __HAVE_DISTINCT_FLOAT128
 extern __typeof (wcstof128_l) __wcstof128_l;
 libc_hidden_proto (__wcstof128_l)
@@ -77,6 +97,9 @@ extern _Float128 __wcstof128_internal (const wchar_t *__restrict __nptr,
 				       wchar_t **__restrict __endptr,
 				       int __group) __THROW;
 
+extern _Float128 ____wcstof128_l_internal (const wchar_t *, wchar_t **, int,
+					   locale_t) attribute_hidden;
+
 libc_hidden_proto (__wcstof128_internal)
 libc_hidden_proto (wcstof128)
 #endif
diff --git a/sysdeps/ieee754/float128/wcstof128.c b/sysdeps/ieee754/float128/wcstof128.c
index 49aa4d61ac..bab8c24040 100644
--- a/sysdeps/ieee754/float128/wcstof128.c
+++ b/sysdeps/ieee754/float128/wcstof128.c
@@ -24,7 +24,4 @@
 /* Bring in _Float128 typedef if needed.  */
 #include <bits/floatn.h>
 
-extern _Float128 ____wcstof128_l_internal (const wchar_t *, wchar_t **, int,
-					   locale_t);
-
 #include "strtof128.c"
diff --git a/sysdeps/ieee754/float128/wcstof128_l.c b/sysdeps/ieee754/float128/wcstof128_l.c
index b295087efe..33fcccdaa6 100644
--- a/sysdeps/ieee754/float128/wcstof128_l.c
+++ b/sysdeps/ieee754/float128/wcstof128_l.c
@@ -24,7 +24,4 @@
 
 #include <bits/floatn.h>
 
-extern _Float128 ____wcstof128_l_internal (const wchar_t *, wchar_t **, int,
-					   locale_t);
-
 #include "strtof128_l.c"
diff --git a/wcsmbs/wcstod.c b/wcsmbs/wcstod.c
index 4604f51621..4c6343c040 100644
--- a/wcsmbs/wcstod.c
+++ b/wcsmbs/wcstod.c
@@ -22,7 +22,4 @@
 
 #define	USE_WIDE_CHAR	1
 
-extern double ____wcstod_l_internal (const wchar_t *, wchar_t **, int,
-				     locale_t);
-
 #include <stdlib/strtod.c>
diff --git a/wcsmbs/wcstod_l.c b/wcsmbs/wcstod_l.c
index 7790f5abb7..25effe9681 100644
--- a/wcsmbs/wcstod_l.c
+++ b/wcsmbs/wcstod_l.c
@@ -21,9 +21,6 @@
 #include <locale.h>
 
 
-extern double ____wcstod_l_internal (const wchar_t *, wchar_t **, int,
-				     locale_t);
-
 #define	USE_WIDE_CHAR	1
 
 #include <stdlib/strtod_l.c>
diff --git a/wcsmbs/wcstof.c b/wcsmbs/wcstof.c
index e91c09cd53..1f91ab5478 100644
--- a/wcsmbs/wcstof.c
+++ b/wcsmbs/wcstof.c
@@ -21,7 +21,4 @@
 
 #define	USE_WIDE_CHAR	1
 
-extern float ____wcstof_l_internal (const wchar_t *, wchar_t **, int,
-				    locale_t);
-
 #include <stdlib/strtof.c>
diff --git a/wcsmbs/wcstof_l.c b/wcsmbs/wcstof_l.c
index 143b716d07..8b99b69e48 100644
--- a/wcsmbs/wcstof_l.c
+++ b/wcsmbs/wcstof_l.c
@@ -23,7 +23,4 @@
 
 #define	USE_WIDE_CHAR	1
 
-extern float ____wcstof_l_internal (const wchar_t *, wchar_t **, int,
-				    locale_t);
-
 #include <stdlib/strtof_l.c>
diff --git a/wcsmbs/wcstol_l.c b/wcsmbs/wcstol_l.c
index 42bd8429d0..36eaf562b4 100644
--- a/wcsmbs/wcstol_l.c
+++ b/wcsmbs/wcstol_l.c
@@ -23,7 +23,4 @@
 
 #define	USE_WIDE_CHAR	1
 
-extern long int ____wcstol_l_internal (const wchar_t *, wchar_t **, int, int,
-				       locale_t);
-
 #include <stdlib/strtol_l.c>
diff --git a/wcsmbs/wcstold.c b/wcsmbs/wcstold.c
index 7a14cd2871..481fcc4035 100644
--- a/wcsmbs/wcstold.c
+++ b/wcsmbs/wcstold.c
@@ -21,7 +21,4 @@
 
 #define USE_WIDE_CHAR	1
 
-extern long double ____wcstold_l_internal (const wchar_t *, wchar_t **, int,
-					   locale_t);
-
 #include <stdlib/strtold.c>
diff --git a/wcsmbs/wcstold_l.c b/wcsmbs/wcstold_l.c
index a7ab025792..8192620bcc 100644
--- a/wcsmbs/wcstold_l.c
+++ b/wcsmbs/wcstold_l.c
@@ -22,7 +22,4 @@
 
 #define USE_WIDE_CHAR	1
 
-extern long double ____wcstold_l_internal (const wchar_t *, wchar_t **, int,
-					   locale_t);
-
 #include <strtold_l.c>
diff --git a/wcsmbs/wcstoll_l.c b/wcsmbs/wcstoll_l.c
index 598d3f5fff..4a71282346 100644
--- a/wcsmbs/wcstoll_l.c
+++ b/wcsmbs/wcstoll_l.c
@@ -23,7 +23,4 @@
 
 #define QUAD	1
 
-extern long long int ____wcstoll_l_internal (const wchar_t *, wchar_t **,
-					     int, int, locale_t);
-
 #include <wcstol_l.c>
diff --git a/wcsmbs/wcstoul_l.c b/wcsmbs/wcstoul_l.c
index f9f3808b20..1a345d4bb0 100644
--- a/wcsmbs/wcstoul_l.c
+++ b/wcsmbs/wcstoul_l.c
@@ -23,7 +23,4 @@
 
 #define UNSIGNED	1
 
-extern unsigned long int ____wcstoul_l_internal (const wchar_t *, wchar_t **,
-						 int, int, locale_t);
-
 #include "wcstol_l.c"
diff --git a/wcsmbs/wcstoull_l.c b/wcsmbs/wcstoull_l.c
index 412a9fcf0a..1666d5070e 100644
--- a/wcsmbs/wcstoull_l.c
+++ b/wcsmbs/wcstoull_l.c
@@ -23,8 +23,4 @@
 
 #define UNSIGNED	1
 
-extern unsigned long long int ____wcstoull_l_internal (const wchar_t *,
-						       wchar_t **, int, int,
-						       locale_t);
-
 #include <wcstoll_l.c>